/*
 * Library of Useful Stuff (LOUS), a collection of useful functions
 * Copyright (C) 2001,2002,2004 Chris G. Davis <davis@lrtw.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef LOUS_SRC_INCLUDE_LOUS_H
#define LOUS_SRC_INCLUDE_LOUS_H

#ident "@(#)lous.h 1.6      04/02/16 Chris G. Davis"

/** \file src/include/lous.h
 *  \brief General LOUS definitions
 *
 */

/*
 *  Boolean type
 */
enum Bool { false=0, true=1};
typedef enum Bool            bool_t;

enum State { toggle=-2, get=-1, clear=0, set=1};
typedef enum State           state_t;

enum Compare { lessthen=-1, equal=0, greaterthen=1 };
typedef enum Compare         comp_t;

typedef signed char          s8_t;
typedef signed short         s16_t;
typedef signed int           s32_t;
typedef signed long long     s64_t;

typedef unsigned char        u8_t;
typedef unsigned short       u16_t;
typedef unsigned int         u32_t;
typedef unsigned long long   u64_t;

#include "lous/logging.h"
#include "lous/alloc.h"

#endif /* LOUS_SRC_INCLUDE_LOUS_H */
