/*
 * Library of Useful Stuff (LOUS), a collection of useful functions
 * Copyright (C) 2004 Chris G. Davis <davis@lrtw.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef LOUS_SRC_STRING_INTERNAL_TOKENIZER_H
#define LOUS_SRC_STRING_INTERNAL_TOKENIZER_H

#ident "@(#)tokenizer.h 1.2      04/02/21 Chris G. Davis"

/** \file src/string/internal/tokenizer.h
 *  \brief Tokenizer internal definitions
 *  \author Chris G. Davis
 *
*/


struct Tokenizer {
  char* separators;
  s32_t num_separators;

  char* terminators;
  s32_t num_terminators;

  char* ignored;
  s32_t num_ignored;

};

struct Tokenizer_Token_Entry;
typedef struct Tokenizer_Token_Entry tokenizer_ent_t;

struct Tokenizer_Token_Entry {
  char* preceeding;
  char* string;
  char* token;
  char* remainder;
};

struct Tokenizer_Response {
  s32_t num_tokens;
  bool_t got_terminator;
  bool_t is_partial;

  linkedlist_t* tokens;

};

#endif /* LOUS_SRC_STRING_INTERNAL_TOKENIZER_H */
