/*
 * Library of Useful Stuff (LOUS), a collection of useful functions
 * Copyright (C) 2004 Chris G. Davis <davis@lrtw.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef LOUS_SRC_STRUCTURES_INTERNAL_ITERATOR_H
#define LOUS_SRC_STRUCTURES_INTERNAL_ITERATOR_H

#ident "@(#)iterator.h 1.2      04/02/21 Chris G. Davis"

/** \file src/structures/internal/iterator.h
 *  \brief Iterator internal definitions
 *  \author Chris G. Davis
 *
 */

struct LOUS_Iterator_List_Key;
typedef struct LOUS_Iterator_Entry_Key iterator_entry_key_t;

struct LOUS_Iterator_List_Key_Ptr;
typedef struct LOUS_Iterator_Entry_Key iterator_entry_key_ptr_t;

struct LOUS_Iterator_List_Comp;
typedef struct LOUS_Iterator_List_Comp iterator_list_comp_t;

struct LOUS_Iterator_List_Comp {
  iterator_entry_t* first;
  iterator_entry_t* end;

  /**
   * virtual entries, pulled in from list structure 
   */
  comp_t (*comp_func)(void* keya, void* keyb, s32_t keylen);
  s32_t keylen;
};

struct LOUS_Iterator_Entry_Key {
  iterator_entry_t* next;
  iterator_entry_t* prev;

  char key[0];
};

struct LOUS_Iterator_Entry_Key_Ptr {
  iterator_entry_t* next;
  iterator_entry_t* prev;

  char* key;
};


struct LOUS_Iterator {
  iterator_list_t* list;

  iterator_entry_t* prev;
  iterator_entry_t* last;
  iterator_entry_t* next;
};


#endif /* LOUS_SRC_STRUCTURES_INTERNAL_ITERATOR_H */
