/*
 * Library of Useful Stuff (LOUS), a collection of useful functions
 * Copyright (C) 2002,2004 Chris G. Davis <davis@lrtw.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ident "@(#)basictest.c 1.5      04/02/23 Chris G. Davis"

/** \file tests/t0002/basictest.c
 *  \brief
 *  \author Chris G. Davis 
 *
*/

#include <stdio.h>

#include "lous/lous.h"
#include "lous/logging.h"
s32_t D_test1;
s32_t D_test2;
s32_t D_test3;
s32_t DL_l1;
s32_t DL_l2;
s32_t DL_l3;

int main() {
	loggroup_t* logging;
	s32_t ret;

	logging = loggroup_init(true);
	if( logging == NULL ) {
		printf("can't init loggroup\n");
		exit(-1);
	}


	D_test1 = loggroup_reg_class(logging, "tclass 1");
	printf("add class tclass1, got %d\n", D_test1);

	D_test2 = loggroup_reg_class(logging, "tclass 2");
	printf("add class tclass2, got %d\n", D_test2);

	D_test3 = loggroup_reg_class(logging, "tclass 3");
	printf("add class tclass3, got %d\n", D_test3);

	DL_l1 = loggroup_reg_level(logging, "level 1");
	printf("add level l1, got %d\n", DL_l1);

	DL_l2 = loggroup_reg_level(logging, "level 2");
	printf("add level l2, got %d\n", DL_l2);

	DL_l3 = loggroup_reg_level(logging, "level 3");
	printf("add level l3, got %d\n", DL_l3);

	ret = loggroup_dereg_class(logging, D_test3);
	printf("got back %d => [%d] %s\n", ret, errno, strerror(errno));

	ret = loggroup_dereg_class_name(logging, "tclass 1");
	printf("got back %d => [%d] %s\n", ret, errno, strerror(errno));

	ret = loggroup_dereg_class_name(logging, "tclass 2");
	printf("got back %d => [%d] %s\n", ret, errno, strerror(errno));

	D_test1 = loggroup_reg_class(logging, "tclass 1a");
	printf("add class tclass1a, got %d\n", D_test1);

	D_test2 = loggroup_reg_class(logging, "tclass 2a");
	printf("add class tclass2a, got %d\n", D_test2);

	D_test3 = loggroup_reg_class(logging, "tclass 3a");
	printf("add class tclass3a, got %d\n", D_test3);

	ret = loggroup_destroy( logging );
	printf("got back %d => [%d] %s\n", ret, errno, strerror(errno));

	return 0;
}
