/*
 * Library of Useful Stuff (LOUS), a collection of useful functions
 * Copyright (C) 2002,2004 Chris G. Davis <davis@lrtw.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ident "@(#)lousdebug.c 1.5      04/02/16 Chris G. Davis"

/** \file tests_t0002_lousdebug_c
 *  \brief
 *  \author Chris G. Davis 
 *
*/

#include <stdio.h>
#include "lous/lous.h"
#include "lous/logging.h"

int testfunc(s32_t val) {
	LDFunc();
	LDParam(val, != val, "%d", -1);

	return 0;
}

int main() {
	LOUS_Debug_Init(LOG_STDERR | LOG_NODATE | LOG_NOTIME,0);
	LOUS_SetDebug(LD_func, LL_veryverbose);
	LOUS_SetDebug(LD_debug, LL_veryverbose);

#ifdef LOUS_DEBUG
	printf("Debugging on\n");
#else
	printf("Debugging off\n");
#endif
	testfunc(4);

	LDebug(LD_debug, LL_verbose, "Test message %d", 5);

	return 0;
}

