/*
 * Library of Useful Stuff (LOUS), a collection of useful functions
 * Copyright (C) 2002,2004 Chris G. Davis <davis@lrtw.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ident "@(#)basic.c 1.5      04/02/16 Chris G. Davis"

/** \file tests_t0004_basic_c
 *  \brief
 *  \author Chris G. Davis 
 *
*/

#include <stdio.h>
#include "lous/lous.h"
#include "lous/logging.h"
#include "lous/splay.h"

int main() {
	splay_tree_t* tree;
	char* data;

        LOUS_Debug_Init(LOG_STDERR | LOG_NODATE | LOG_NOTIME,0);
        LOUS_SetDebug(LD_func, LL_veryverbose);
        LOUS_SetDebug(LD_debug, LL_veryverbose);

	tree = splay_alloc(0, 0, NULL, NULL);

	splay_insert(tree, "key1", "dataval1");
	splay_insert(tree, "key2", "dataval2");
	splay_insert(tree, "key3", "dataval3");
	splay_insert(tree, "key4", "dataval4");
	splay_insert(tree, "key5", "dataval5");
	splay_insert(tree, "key6", "dataval6");
	splay_insert(tree, "key7", "dataval7");
	splay_insert(tree, "key8", "dataval8");
	splay_insert(tree, "key9", "dataval9");
	splay_insert(tree, "key10", "dataval10");
	splay_insert(tree, "key11", "dataval11");

	data = splay_lookup(tree, "key5");
	printf("Got %s\n", data);

	data = splay_lookup(tree, "key2");
	printf("Got %s\n", data);

	data = splay_lookup(tree, "key1");
	printf("Got %s\n", data);

	data = splay_lookup(tree, "key8");
	printf("Got %s\n", data);

	data = splay_lookup(tree, "key12");
	printf("Got %s\n", data);

	data = splay_lookup(tree, "key6");
	printf("Got %s\n", data);

	data = splay_remove(tree, "key8");
	printf("Got %s\n", data);

	data = splay_lookup(tree, "key8");
	printf("Got %s\n", data);

	return 0;
}
