/*
 * Library of Useful Stuff (LOUS), a collection of useful functions
 * Copyright (C) 2002,2004 Chris G. Davis <davis@lrtw.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ident "@(#)splay-hash-lifo.c 1.1      04/02/16 Chris G. Davis"

/** \file tests/t0004/splay-hash.c
 *  \brief
 *  \author Chris G. Davis 
 *
*/

#include <stdio.h>
#include <stdlib.h>
#include "lous/lous.h"
#include "lous/logging.h"
#include "lous/hash.h"
#include "lous/splay.h"
#include "lous/iterator.h"

struct test_ent {
	iterator_entry_t iterate;

	char key[32];
	char data[32];
};
#define do_insert(ky, di) \
ent = malloc( sizeof( struct test_ent )); \
strcpy(ent->key, ky); \
strcpy(ent->data, di); \
hash_insert(hash, ky, ent)

int main() {
	hash_t* hash;
        char* data;
        char buffer[64];
        FILE* dict;
        char* ret;
	struct test_ent* ent;
	iterator_t* iter;

        LOUS_Debug_Init(LOG_STDERR | LOG_NODATE | LOG_NOTIME,0);
        LOUS_SetDebug(LD_func, LL_veryverbose);
        LOUS_SetDebug(LD_debug, LL_veryverbose);

	hash = hash_alloc(32, 0, 
		HASH_MULTIPLEX | HASH_SPLAY | LIST_KEEPLIFO, 
		NULL, NULL, NULL);

	do_insert("330026566", "dataitem1");
	do_insert("330016628", "dataitem2");
	do_insert("330002140", "dataitem3");
	do_insert("330017715", "dataitem4");
	do_insert("330007806", "dataitem5");
	do_insert("330009558", "dataitem6");
	do_insert("330028715", "dataitem7");
	do_insert("330029637", "dataitem8");
	do_insert("330019684", "dataitem9");
	do_insert("330013131", "dataitem10");
	do_insert("330032601", "dataitem11");
	do_insert("330005161", "dataitem12");
	do_insert("330029223", "dataitem13");
	do_insert("330012695", "dataitem14");
	do_insert("330017852", "dataitem15");
	do_insert("330016887", "dataitem16");
	do_insert("330027416", "dataitem17");
	do_insert("330024091", "dataitem18");
	do_insert("330008832", "dataitem19");
	do_insert("330002721", "dataitem20");

	iter = iterator_alloc(hash);

	while( (ret = iterator_getnext(iter)) != NULL ) {
//		data = hash_lookup(hash, ret);

		printf("%s\n", ((struct test_ent*)ret)->data );
	}
	
	return 0;
}


