/*
 * Library of Useful Stuff (LOUS), a collection of useful functions
 * Copyright (C) 2004 Chris G. Davis <davis@lrtw.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ident "@(#)basic.c 1.1      04/02/09 Chris G. Davis"

/** \file tests/t0008/basic.c
 *  \brief
 *  \author Chris G. Davis 
 *
*/
#include <stdio.h>
#include <stdlib.h>
#include "lous/lous.h"

void test1() {
	LMEM();

	LEND();
}

void test2() {
	void* d;
	LMEM();

	d = lalloc(56);

	lfree(d);

	LEND();
}

void test3() {
	void* d;
	LMEM();

	d = lalloc(56);

	LEND();
}

void test3b() {
	void* d;
	LMEM();

	d = lalloc(56);

	LLOSE(56);

	LEND();
}

void test4() {
	void* d;
	LMEM();

	d = lalloc(56);

	lfree(d);
	lfree(d);
	LEND();
}

void* test5() {
	void* retval;
	LMEM();

	retval = lalloc(243);

	LLOSE(243);

	LEND();

	return retval;
}

void test6(void* it) {
	LMEM();

	lfree(it);

	LFIND(243);
	LEND();
}

int main() {

	int i;
	void* list[100000];

	LINIT(stderr, 0);

	test1();
	test2();
	test3();
	test3b();
	test4();

	for(i=0;i< 99; i++) {
		list[i] = test5();
	}

	for(i=0;i< 90; i++) {
		test6(list[i]);
		list[i] = NULL;
	}
	
	fflush(stdout);
	fflush(stderr);
	return 0;
}

