/*
 * Library of Useful Stuff (LOUS), a collection of useful functions
 * Copyright (C) 2002,2004 Chris G. Davis <davis@lrtw.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ident "@(#)basic.c 1.1      04/02/21 Chris G. Davis"

/** \file tests/t0009/basic.c
 *  \brief
 *  \author Chris G. Davis 
 *
*/
#include <stdio.h>
#include "lous/cli.h"
#include "lous/cli-macro.h"

CLI_FUNC(first, test) {
  cli_return(CLI_COMMAND_SUCCESS);
}

CLI_FUNC(second, test) {
  cli_return(CLI_COMMAND_SUCCESS);
}

CLI_FUNC(third, test) {
  cli_return(CLI_COMMAND_SUCCESS);
}

CLI_FUNC_NI(show, test);

CLI_FUNC(general, test_show) {
  cli_return(CLI_COMMAND_SUCCESS);
}

CLI_FUNC(ip, test_show) {
  cli_return(CLI_COMMAND_SUCCESS);
}

CLI_FUNC(address, test_show_ip) {
  cli_return(CLI_COMMAND_SUCCESS);
}

CLI_FUNC(detail, test_show_ip_address) {
  cli_return(CLI_COMMAND_SUCCESS);
}

CLI_FUNC(id, test_show) {
  cli_return(CLI_COMMAND_SUCCESS);
}

CLI_FUNC(ident, test_show_id) {
  cli_return(CLI_COMMAND_SUCCESS);
}

CLI_FUNC(again, test_show) {
  cli_return(CLI_COMMAND_SUCCESS);
}

CLI_FUNC(last, test) {
  cli_return(CLI_COMMAND_SUCCESS);
}

CLI_EXPANDER(id_expand) {
  cli_return(CLI_COMMAND_SUCCESS);
}

cli_item_t* cli_init() {
  CLI_NEWROOT(test) {
    CLI_FUNCTION(first, test, "the first function",0);
    CLI_FUNCTION(second, test, "the second function",0);
    CLI_FUNCTION(third, test, "the third function",0);
    CLI_BRANCH(show, test, "show info",0) {
      CLI_FUNCTION(general, test_show, "show general info",0);
      CLI_BRANCH(ip, test_show, "show info about ip address",0) {
	CLI_PARAMBRANCH(address, test_show_ip, "(([01]?[0-9][0-9])|(2[0-5][0-9]).){3}(([01]?[0-9][0-9])|(2[0-5][0-9]))", NULL, "ip address",0) {
	  CLI_FUNCTION(detail, test_show_ip_address, "show detail info",0);
	}
      }
      CLI_BRANCH(id, test_show, "show info about id address",0) {
	CLI_PARAM(ident, test_show_id, "33[[:xdigit:]]{14}", id_expand, "show info about id",0);
      }
      CLI_FUNCTION(again, test_show, "again, test the sort",0);
    }
    CLI_FUNCTION(last, test, "the last function",0);
  }

  return test;
}

int main() {
  cli_item_t* test;

  LOUS_Debug_Init(LOG_STDERR | LOG_NODATE | LOG_NOTIME,0);
  LOUS_SetDebug(LD_func, LL_veryverbose);
  LOUS_SetDebug(LD_debug, LL_veryverbose);

  test = cli_init();

  cli_item_display(test, 0);

  return 0;
}

